---
updatedAt: 2026-05-27T07:53:00.000Z
agentTools:
  projectIndex: https://developers.asana.com/llms.txt
---

# Get multiple tasks

<b>Required scope: </b><code>tasks:read</code>

Returns the compact task records for some filtered set of tasks. Use one or more of the parameters provided to filter the tasks returned. You must specify a `project` or `tag` if you do not specify `assignee` and `workspace`.

For more complex task retrieval, use [workspaces/{workspace_gid}/tasks/search](/reference/searchtasksforworkspace).

> 📘 Customizing the response
>
> Requests to this endpoint return "compact" task objects ([schema](/reference/tasks)) by default. To include more fields in the response, see [input/output options](/docs/inputoutput-options).

# OpenAPI definition

```json
{
  "openapi": "3.0.0",
  "info": {
    "description": "This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).",
    "x-public-description": "This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).",
    "title": "Asana",
    "termsOfService": "https://asana.com/terms",
    "contact": {
      "name": "Asana Support",
      "url": "https://asana.com/support"
    },
    "license": {
      "name": "Apache 2.0",
      "url": "https://www.apache.org/licenses/LICENSE-2.0"
    },
    "version": "1.0",
    "x-docs-schema-whitelist": [
      "AgentCompact",
      "AgentResponse",
      "AsanaResource",
      "AsanaNamedResource",
      "AuditLogEvent",
      "AttachmentResponse",
      "AttachmentCompact",
      "BatchResponse",
      "CustomFieldSettingResponse",
      "CustomFieldSettingCompact",
      "CustomTypeResponse",
      "CustomTypeBase",
      "CustomTypeCompact",
      "CustomTypeStatusOptionResponse",
      "CustomTypeStatusOptionBase",
      "CustomTypeStatusOptionCompact",
      "CustomFieldResponse",
      "CustomFieldCompact",
      "CustomFieldMembershipCompact",
      "CustomFieldMembershipResponse",
      "EnumOption",
      "EventResponse",
      "ErrorResponse",
      "GoalResponse",
      "GoalCompact",
      "GoalMembershipCompact",
      "GoalMembershipBase",
      "GoalMembershipResponse",
      "GoalRelationshipResponse",
      "GoalRelationshipCompact",
      "GraphExportResponse",
      "GraphExportCompact",
      "JobResponse",
      "JobCompact",
      "OrganizationExportResponse",
      "OrganizationExportCompact",
      "PortfolioMembershipResponse",
      "PortfolioMembershipCompact",
      "PortfolioResponse",
      "PortfolioCompact",
      "PortfolioItemCompact",
      "ProjectBriefResponse",
      "ProjectBriefCompact",
      "ProjectMembershipCompactResponse",
      "ProjectMembershipNormalResponse",
      "ProjectMembershipCompact",
      "ProjectResponse",
      "ProjectCompact",
      "ProjectStatusResponse",
      "ProjectStatusCompact",
      "ProjectTemplateCompact",
      "ProjectTemplateResponse",
      "RuleTriggerResponse",
      "ResourceExportResponse",
      "ResourceExportCompact",
      "ResourceExportCompact",
      "RbacRoleResponse",
      "RbacRoleCompact",
      "SectionResponse",
      "SectionCompact",
      "StatusUpdateResponse",
      "StatusUpdateCompact",
      "StoryResponse",
      "StoryCompact",
      "TagResponse",
      "TagCompact",
      "TaskResponse",
      "TaskCompact",
      "TaskCountResponse",
      "TeamMembershipResponse",
      "TeamMembershipCompact",
      "TeamResponse",
      "TeamCompact",
      "TimePeriodResponse",
      "TimePeriodCompact",
      "TimeTrackingCategoryResponse",
      "TimeTrackingCategoryCompact",
      "UserTaskListResponse",
      "UserTaskListCompact",
      "UserResponse",
      "UserCompact",
      "WebhookFilter",
      "WebhookResponse",
      "WebhookCompact",
      "WorkspaceMembershipResponse",
      "WorkspaceMembershipCompact",
      "WorkspaceResponse",
      "WorkspaceCompact"
    ]
  },
  "servers": [
    {
      "url": "https://app.asana.com/api/1.0",
      "description": "Main endpoint."
    }
  ],
  "security": [
    {
      "personalAccessToken": []
    },
    {
      "oauth2": []
    }
  ],
  "x-readme": {
    "proxy-enabled": false
  },
  "tags": [
    {
      "name": "Tasks",
      "description": "The task is the basic object around which many operations in Asana are centered. In the Asana application, multiple tasks populate the middle pane according to some view parameters, and the set of selected tasks determines the more detailed information presented in the details pane.\n\nSections are unique in that they will be included in the `memberships` field of task objects returned in the API when the task is within a section. They can also be used to manipulate the ordering of a task within a project.\n\n[Queries](/reference/gettasks) return a [compact representation of each task object](/reference/tasks). To retrieve *all* fields or *specific set* of the fields, use [field selectors](/docs/inputoutput-options) to manipulate what data is included in a response."
    }
  ],
  "components": {
    "parameters": {
      "pretty": {
        "name": "opt_pretty",
        "in": "query",
        "description": "Provides “pretty” output.\nProvides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.",
        "required": false,
        "allowEmptyValue": true,
        "schema": {
          "type": "boolean"
        },
        "style": "form",
        "example": true
      },
      "limit": {
        "name": "limit",
        "in": "query",
        "description": "Results per page.\nThe number of objects to return per page. The value must be between 1 and 100.",
        "example": 50,
        "schema": {
          "type": "integer",
          "minimum": 1,
          "maximum": 100
        }
      },
      "offset": {
        "name": "offset",
        "in": "query",
        "description": "Offset token.\nAn offset to the next page returned by the API. A pagination request will return an offset token, which can be used as an input parameter to the next request. If an offset is not passed in, the API will return the first page of results.\n*Note: You can only pass in an offset that was returned to you via a previously paginated request.*",
        "example": "eyJ0eXAiOJiKV1iQLCJhbGciOiJIUzI1NiJ9",
        "schema": {
          "type": "string"
        }
      },
      "custom_type_query_param": {
        "name": "custom_type",
        "in": "query",
        "description": "Filter results by custom type. Provide a custom type GID to return only objects of that custom type (an unknown GID returns `400`). Provide an empty string to return only objects with no custom type assigned. If this parameter is omitted, results are not filtered by custom type.",
        "required": false,
        "schema": {
          "type": "string"
        },
        "example": "12345",
        "x-env-variable": "custom_type"
      }
    },
    "responses": {
      "BadRequest": {
        "description": "This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/ErrorResponse"
            }
          }
        }
      },
      "Unauthorized": {
        "description": "A valid authentication token was not provided with the request, so the API could not associate a user with the request.",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/ErrorResponse"
            }
          }
        }
      },
      "Forbidden": {
        "description": "The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/ErrorResponse"
            }
          }
        }
      },
      "NotFound": {
        "description": "Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/ErrorResponse"
            }
          }
        }
      },
      "InternalServerError": {
        "description": "There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/ErrorResponse"
            }
          }
        }
      }
    },
    "schemas": {
      "Error": {
        "type": "object",
        "properties": {
          "message": {
            "type": "string",
            "readOnly": true,
            "description": "Message providing more detail about the error that occurred, if available.",
            "example": "project: Missing input"
          },
          "help": {
            "type": "string",
            "readOnly": true,
            "description": "Additional information directing developers to resources on how to address and fix the problem, if available.",
            "example": "For more information on API status codes and how to handle them, read the docs on errors: https://asana.github.io/developer-docs/#errors'"
          },
          "phrase": {
            "type": "string",
            "readOnly": true,
            "description": "*500 errors only*. A unique error phrase which can be used when contacting developer support to help identify the exact occurrence of the problem in Asana's logs.",
            "example": "6 sad squid snuggle softly"
          }
        }
      },
      "ErrorResponse": {
        "description": "Sadly, sometimes requests to the API are not successful. Failures can\noccur for a wide range of reasons. In all cases, the API should return\nan HTTP Status Code that indicates the nature of the failure,\nwith a response body in JSON format containing additional information.\n\n\nIn the event of a server error the response body will contain an error\nphrase. These phrases are automatically generated using the\n[node-asana-phrase\nlibrary](https://github.com/Asana/node-asana-phrase) and can be used by\nAsana support to quickly look up the incident that caused the server\nerror.",
        "type": "object",
        "properties": {
          "errors": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Error"
            }
          }
        }
      },
      "NextPage": {
        "type": "object",
        "nullable": true,
        "description": "*Conditional*. This property is only present when a limit query parameter is provided in the request. When making a paginated request, the API will return a number of results as specified by the limit parameter. If more results exist, then the response will contain a next_page attribute, which will include an offset, a relative path attribute, and a full uri attribute. If there are no more pages available, next_page will be null and no offset will be provided. Note that an offset token will expire after some time, as data may have changed.",
        "properties": {
          "offset": {
            "type": "string",
            "readOnly": true,
            "description": "Pagination offset for the request.",
            "example": "eyJ0eXAiOJiKV1iQLCJhbGciOiJIUzI1NiJ9"
          },
          "path": {
            "type": "string",
            "readOnly": true,
            "description": "A relative path containing the query parameters to fetch for next_page",
            "example": "/tasks/12345/attachments?limit=2&offset=eyJ0eXAiOJiKV1iQLCJhbGciOiJIUzI1NiJ9"
          },
          "uri": {
            "type": "string",
            "format": "uri",
            "readOnly": true,
            "description": "A full uri containing the query parameters to fetch for next_page",
            "example": "https://app.asana.com/api/1.0/tasks/12345/attachments?limit=2&offset=eyJ0eXAiOJiKV1iQLCJhbGciOiJIUzI1NiJ9"
          }
        }
      },
      "TaskCompact": {
        "description": "The *task* is the basic object around which many operations in Asana are centered.",
        "type": "object",
        "properties": {
          "gid": {
            "description": "Globally unique identifier of the resource, as a string.",
            "type": "string",
            "readOnly": true,
            "example": "12345",
            "x-insert-after": false
          },
          "resource_type": {
            "description": "The base type of this resource.",
            "type": "string",
            "readOnly": true,
            "example": "task",
            "x-insert-after": "gid"
          },
          "name": {
            "description": "The name of the task.",
            "type": "string",
            "example": "Bug Task"
          },
          "resource_subtype": {
            "type": "string",
            "description": "The subtype of this resource. Different subtypes retain many of the same fields and behavior, but may render differently in Asana or represent resources with different semantic meaning.\nThe resource_subtype `milestone` represent a single moment in time. This means tasks with this subtype cannot have a start_date.",
            "enum": [
              "default_task",
              "milestone",
              "approval",
              "custom"
            ],
            "example": "default_task"
          },
          "created_by": {
            "type": "object",
            "readOnly": true,
            "description": "[Opt In](/docs/inputoutput-options). A *user* object represents an account in Asana that can be given access to various workspaces, projects, and tasks.",
            "properties": {
              "gid": {
                "description": "Globally unique identifier of the resource.",
                "type": "string",
                "example": "1111"
              },
              "resource_type": {
                "description": "The type of resource.",
                "type": "string",
                "example": "user"
              }
            }
          }
        }
      }
    },
    "securitySchemes": {
      "personalAccessToken": {
        "type": "http",
        "description": "A personal access token allows access to the api for the user who created it. This should be kept a secret and be treated like a password.",
        "scheme": "bearer"
      },
      "oauth2": {
        "type": "oauth2",
        "description": "We require that applications designed to access the Asana API on behalf of multiple users implement OAuth 2.0.\nAsana supports the Authorization Code Grant flow.",
        "flows": {
          "authorizationCode": {
            "authorizationUrl": "https://app.asana.com/-/oauth_authorize",
            "tokenUrl": "https://app.asana.com/-/oauth_token",
            "refreshUrl": "https://app.asana.com/-/oauth_token",
            "scopes": {
              "default": "Provides access to all endpoints documented in our API reference. If no scopes are requested, this scope is assumed by default.",
              "openid": "Provides access to OpenID Connect ID tokens and the OpenID Connect user info endpoint.",
              "email": "Provides access to the user’s email through the OpenID Connect user info endpoint.",
              "profile": "Provides access to the user’s name and profile photo through the OpenID Connect user info endpoint.",
              "attachments:read": "View access to attachments",
              "attachments:write": "Create and modify access to attachments",
              "attachments:delete": "Delete access to attachments",
              "custom_fields:read": "View access to custom fields",
              "custom_fields:write": "Create and modify access to custom fields",
              "custom_types:read": "View access to custom types",
              "goals:read": "View access to goals",
              "jobs:read": "View access to jobs",
              "notifications:read": "View access to notifications",
              "notifications:write": "Create and modify access to notifications",
              "ooo_entries:read": "View access to OOO entries",
              "ooo_entries:write": "Create and modify access to OOO entries",
              "ooo_entries:delete": "Delete access to OOO entries",
              "tasks:read": "View access to tasks",
              "tasks:write": "Create and modify access to tasks",
              "tasks:delete": "Delete access to tasks",
              "task_custom_types:read": "View access to task custom types",
              "task_templates:read": "View access to task templates",
              "team_memberships:read": "View access to team memberships",
              "portfolios:read": "View access to portfolios",
              "portfolios:write": "Create and modify access to portfolios",
              "project_templates:read": "View access to project templates",
              "project_portfolio_settings:read": "View access to project portfolio settings",
              "project_portfolio_settings:write": "Create and modify access to project portfolio settings",
              "projects:delete": "Delete access to projects",
              "projects:read": "View access to projects",
              "projects:write": "Create and modify access to projects",
              "records:read": "View access to records",
              "records:write": "Create and modify access to records",
              "records:delete": "Delete access to records",
              "roles:read": "View access to roles",
              "roles:write": "Create and modify access to roles",
              "roles:delete": "Delete access to roles",
              "users:read": "View access to users",
              "teams:read": "View access to teams",
              "time_tracking_categories:read": "View access to time tracking categories",
              "time_tracking_categories:write": "Create and modify access to time tracking categories",
              "time_tracking_categories:delete": "Delete access to time tracking categories",
              "time_tracking_entries:read": "View access to time tracking entries",
              "timesheet_approval_statuses:read": "View access to timesheet approval statuses",
              "timesheet_approval_statuses:write": "Create and modify access to timesheet approval statuses",
              "stories:read": "View access to stories",
              "stories:write": "Create and modify access to stories",
              "tables:read": "View access to tables",
              "tables:write": "Create and modify access to tables",
              "tables:delete": "Delete access to tables",
              "tags:read": "View access to tags",
              "tags:write": "Create and modify access to tags",
              "webhooks:read": "View access to webhooks",
              "webhooks:write": "Create and modify access to webhooks",
              "webhooks:delete": "Delete access to webhooks",
              "workspaces:read": "View access to workspaces"
            }
          }
        }
      }
    }
  },
  "paths": {
    "/tasks": {
      "parameters": [
        {
          "$ref": "#/components/parameters/pretty"
        }
      ],
      "get": {
        "summary": "Get multiple tasks",
        "description": "<b>Required scope: </b><code>tasks:read</code>\n\nReturns the compact task records for some filtered set of tasks. Use one or more of the parameters provided to filter the tasks returned. You must specify a `project` or `tag` if you do not specify `assignee` and `workspace`.\n\nFor more complex task retrieval, use [workspaces/{workspace_gid}/tasks/search](/reference/searchtasksforworkspace).",
        "tags": [
          "Tasks"
        ],
        "operationId": "getTasks",
        "parameters": [
          {
            "$ref": "#/components/parameters/limit"
          },
          {
            "$ref": "#/components/parameters/offset"
          },
          {
            "name": "assignee",
            "in": "query",
            "description": "The assignee to filter tasks on. If searching for unassigned tasks, assignee.any = null can be specified.\n*Note: If you specify `assignee`, you must also specify the `workspace` to filter on.*",
            "schema": {
              "type": "string"
            },
            "x-env-variable": "assignee",
            "example": "14641"
          },
          {
            "name": "project",
            "in": "query",
            "description": "The project to filter tasks on.",
            "schema": {
              "type": "string"
            },
            "example": "321654",
            "x-env-variable": "project"
          },
          {
            "name": "section",
            "in": "query",
            "description": "The section to filter tasks on.",
            "schema": {
              "type": "string"
            },
            "example": "321654",
            "x-env-variable": "section"
          },
          {
            "name": "workspace",
            "in": "query",
            "description": "The workspace to filter tasks on.\n*Note: If you specify `workspace`, you must also specify the `assignee` to filter on.*",
            "schema": {
              "type": "string"
            },
            "example": "321654",
            "x-env-variable": "workspace"
          },
          {
            "name": "completed_since",
            "in": "query",
            "description": "Only return tasks that are either incomplete or that have been completed since this time.",
            "schema": {
              "type": "string",
              "format": "date-time",
              "example": "2012-02-22T02:06:58.158Z"
            }
          },
          {
            "name": "modified_since",
            "in": "query",
            "description": "Only return tasks that have been modified since the given time.\n\n*Note: A task is considered “modified” if any of its properties\nchange, or associations between it and other objects are modified\n(e.g.  a task being added to a project). A task is not considered\nmodified just because another object it is associated with (e.g. a\nsubtask) is modified. Actions that count as modifying the task\ninclude assigning, renaming, completing, and adding stories.*",
            "schema": {
              "type": "string",
              "format": "date-time"
            },
            "example": "2012-02-22T02:06:58.158Z"
          },
          {
            "$ref": "#/components/parameters/custom_type_query_param"
          },
          {
            "name": "opt_fields",
            "in": "query",
            "description": "This endpoint returns a resource which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. Properties can include nested fields. To learn more, see the [input/output options guide](/docs/inputoutput-options#selecting-nested-fields).",
            "required": false,
            "example": [
              "actual_time_minutes",
              "approval_status",
              "assigned_by",
              "assigned_by.name",
              "assignee",
              "assignee.name",
              "assignee_section",
              "assignee_section.name",
              "assignee_status",
              "completed",
              "completed_at",
              "completed_by",
              "completed_by.name",
              "created_at",
              "created_by",
              "custom_fields",
              "custom_fields.asana_created_field",
              "custom_fields.created_by",
              "custom_fields.created_by.name",
              "custom_fields.currency_code",
              "custom_fields.custom_label",
              "custom_fields.custom_label_position",
              "custom_fields.date_value",
              "custom_fields.date_value.date",
              "custom_fields.date_value.date_time",
              "custom_fields.default_access_level",
              "custom_fields.description",
              "custom_fields.display_value",
              "custom_fields.enabled",
              "custom_fields.enum_options",
              "custom_fields.enum_options.color",
              "custom_fields.enum_options.enabled",
              "custom_fields.enum_options.name",
              "custom_fields.enum_value",
              "custom_fields.enum_value.color",
              "custom_fields.enum_value.enabled",
              "custom_fields.enum_value.name",
              "custom_fields.format",
              "custom_fields.has_notifications_enabled",
              "custom_fields.html_text_value",
              "custom_fields.id_prefix",
              "custom_fields.input_restrictions",
              "custom_fields.is_formula_field",
              "custom_fields.is_global_to_workspace",
              "custom_fields.is_value_read_only",
              "custom_fields.multi_enum_values",
              "custom_fields.multi_enum_values.color",
              "custom_fields.multi_enum_values.enabled",
              "custom_fields.multi_enum_values.name",
              "custom_fields.name",
              "custom_fields.number_value",
              "custom_fields.people_value",
              "custom_fields.people_value.name",
              "custom_fields.precision",
              "custom_fields.privacy_setting",
              "custom_fields.reference_value",
              "custom_fields.reference_value.name",
              "custom_fields.representation_type",
              "custom_fields.resource_subtype",
              "custom_fields.text_value",
              "custom_fields.type",
              "custom_type",
              "custom_type.asana_created_type_identifier",
              "custom_type.name",
              "custom_type_status_option",
              "custom_type_status_option.name",
              "dependencies",
              "dependents",
              "due_at",
              "due_on",
              "effective_memberships",
              "external",
              "external.data",
              "followers",
              "followers.name",
              "has_subtasks_date_mismatch",
              "hearted",
              "hearts",
              "hearts.user",
              "hearts.user.name",
              "html_notes",
              "is_rendered_as_separator",
              "liked",
              "likes",
              "likes.user",
              "likes.user.name",
              "memberships",
              "memberships.project",
              "memberships.project.name",
              "memberships.project.resource_subtype",
              "memberships.section",
              "memberships.section.name",
              "modified_at",
              "name",
              "notes",
              "num_hearts",
              "num_likes",
              "num_subtasks",
              "offset",
              "parent",
              "parent.created_by",
              "parent.name",
              "parent.resource_subtype",
              "path",
              "permalink_url",
              "projects",
              "projects.name",
              "projects.resource_subtype",
              "resource_subtype",
              "start_at",
              "start_on",
              "tags",
              "tags.name",
              "uri",
              "workspace",
              "workspace.name"
            ],
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "enum": [
                  "actual_time_minutes",
                  "approval_status",
                  "assigned_by",
                  "assigned_by.name",
                  "assignee",
                  "assignee.name",
                  "assignee_section",
                  "assignee_section.name",
                  "assignee_status",
                  "completed",
                  "completed_at",
                  "completed_by",
                  "completed_by.name",
                  "created_at",
                  "created_by",
                  "custom_fields",
                  "custom_fields.asana_created_field",
                  "custom_fields.created_by",
                  "custom_fields.created_by.name",
                  "custom_fields.currency_code",
                  "custom_fields.custom_label",
                  "custom_fields.custom_label_position",
                  "custom_fields.date_value",
                  "custom_fields.date_value.date",
                  "custom_fields.date_value.date_time",
                  "custom_fields.default_access_level",
                  "custom_fields.description",
                  "custom_fields.display_value",
                  "custom_fields.enabled",
                  "custom_fields.enum_options",
                  "custom_fields.enum_options.color",
                  "custom_fields.enum_options.enabled",
                  "custom_fields.enum_options.name",
                  "custom_fields.enum_value",
                  "custom_fields.enum_value.color",
                  "custom_fields.enum_value.enabled",
                  "custom_fields.enum_value.name",
                  "custom_fields.format",
                  "custom_fields.has_notifications_enabled",
                  "custom_fields.html_text_value",
                  "custom_fields.id_prefix",
                  "custom_fields.input_restrictions",
                  "custom_fields.is_formula_field",
                  "custom_fields.is_global_to_workspace",
                  "custom_fields.is_value_read_only",
                  "custom_fields.multi_enum_values",
                  "custom_fields.multi_enum_values.color",
                  "custom_fields.multi_enum_values.enabled",
                  "custom_fields.multi_enum_values.name",
                  "custom_fields.name",
                  "custom_fields.number_value",
                  "custom_fields.people_value",
                  "custom_fields.people_value.name",
                  "custom_fields.precision",
                  "custom_fields.privacy_setting",
                  "custom_fields.reference_value",
                  "custom_fields.reference_value.name",
                  "custom_fields.representation_type",
                  "custom_fields.resource_subtype",
                  "custom_fields.text_value",
                  "custom_fields.type",
                  "custom_type",
                  "custom_type.asana_created_type_identifier",
                  "custom_type.name",
                  "custom_type_status_option",
                  "custom_type_status_option.name",
                  "dependencies",
                  "dependents",
                  "due_at",
                  "due_on",
                  "effective_memberships",
                  "external",
                  "external.data",
                  "followers",
                  "followers.name",
                  "has_subtasks_date_mismatch",
                  "hearted",
                  "hearts",
                  "hearts.user",
                  "hearts.user.name",
                  "html_notes",
                  "is_rendered_as_separator",
                  "liked",
                  "likes",
                  "likes.user",
                  "likes.user.name",
                  "memberships",
                  "memberships.project",
                  "memberships.project.name",
                  "memberships.project.resource_subtype",
                  "memberships.section",
                  "memberships.section.name",
                  "modified_at",
                  "name",
                  "notes",
                  "num_hearts",
                  "num_likes",
                  "num_subtasks",
                  "offset",
                  "parent",
                  "parent.created_by",
                  "parent.name",
                  "parent.resource_subtype",
                  "path",
                  "permalink_url",
                  "projects",
                  "projects.name",
                  "projects.resource_subtype",
                  "resource_subtype",
                  "start_at",
                  "start_on",
                  "tags",
                  "tags.name",
                  "uri",
                  "workspace",
                  "workspace.name"
                ]
              }
            },
            "style": "form",
            "explode": false
          }
        ],
        "responses": {
          "200": {
            "description": "Successfully retrieved requested tasks.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "data": {
                      "type": "array",
                      "items": {
                        "$ref": "#/components/schemas/TaskCompact"
                      }
                    },
                    "next_page": {
                      "$ref": "#/components/schemas/NextPage"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        },
        "security": [
          {
            "personalAccessToken": []
          },
          {
            "oauth2": [
              "tasks:read"
            ]
          }
        ],
        "x-readme": {
          "code-samples": [
            {
              "language": "java",
              "install": "<dependency><groupId>com.asana</groupId><artifactId>asana</artifactId><version>1.0.0</version></dependency>",
              "code": "import com.asana.Client;\n\nClient client = Client.accessToken(\"PERSONAL_ACCESS_TOKEN\");\n\nList<Task> result = client.tasks.getTasks(modifiedSince, completedSince, workspace, section, project, assignee)\n    .option(\"pretty\", true)\n    .execute();"
            },
            {
              "language": "node",
              "install": "npm install asana",
              "code": "const Asana = require('asana');\n\nlet client = new Asana.ApiClient();\nclient.authentications.token.accessToken = '<YOUR_ACCESS_TOKEN>';\n\nlet tasksApiInstance = new Asana.TasksApi(client);\nlet opts = { \n    'limit': 50, \n    'offset': \"eyJ0eXAiOJiKV1iQLCJhbGciOiJIUzI1NiJ9\", \n    'assignee': \"14641\", \n    'project': \"321654\", \n    'section': \"321654\", \n    'workspace': \"321654\", \n    'completed_since': \"2012-02-22T02:06:58.158Z\", \n    'modified_since': \"2012-02-22T02:06:58.158Z\", \n    'custom_type': \"12345\", \n    'opt_fields': \"actual_time_minutes,approval_status,assigned_by,assigned_by.name,assignee,assignee.name,assignee_section,assignee_section.name,assignee_status,completed,completed_at,completed_by,completed_by.name,created_at,created_by,custom_fields,custom_fields.asana_created_field,custom_fields.created_by,custom_fields.created_by.name,custom_fields.currency_code,custom_fields.custom_label,custom_fields.custom_label_position,custom_fields.date_value,custom_fields.date_value.date,custom_fields.date_value.date_time,custom_fields.default_access_level,custom_fields.description,custom_fields.display_value,custom_fields.enabled,custom_fields.enum_options,custom_fields.enum_options.color,custom_fields.enum_options.enabled,custom_fields.enum_options.name,custom_fields.enum_value,custom_fields.enum_value.color,custom_fields.enum_value.enabled,custom_fields.enum_value.name,custom_fields.format,custom_fields.has_notifications_enabled,custom_fields.html_text_value,custom_fields.id_prefix,custom_fields.input_restrictions,custom_fields.is_formula_field,custom_fields.is_global_to_workspace,custom_fields.is_value_read_only,custom_fields.multi_enum_values,custom_fields.multi_enum_values.color,custom_fields.multi_enum_values.enabled,custom_fields.multi_enum_values.name,custom_fields.name,custom_fields.number_value,custom_fields.people_value,custom_fields.people_value.name,custom_fields.precision,custom_fields.privacy_setting,custom_fields.reference_value,custom_fields.reference_value.name,custom_fields.representation_type,custom_fields.resource_subtype,custom_fields.text_value,custom_fields.type,custom_type,custom_type.asana_created_type_identifier,custom_type.name,custom_type_status_option,custom_type_status_option.name,dependencies,dependents,due_at,due_on,effective_memberships,external,external.data,followers,followers.name,has_subtasks_date_mismatch,hearted,hearts,hearts.user,hearts.user.name,html_notes,is_rendered_as_separator,liked,likes,likes.user,likes.user.name,memberships,memberships.project,memberships.project.name,memberships.project.resource_subtype,memberships.section,memberships.section.name,modified_at,name,notes,num_hearts,num_likes,num_subtasks,offset,parent,parent.created_by,parent.name,parent.resource_subtype,path,permalink_url,projects,projects.name,projects.resource_subtype,resource_subtype,start_at,start_on,tags,tags.name,uri,workspace,workspace.name\"\n};\ntasksApiInstance.getTasks(opts).then((result) => {\n    console.log('API called successfully. Returned data: ' + JSON.stringify(result.data, null, 2));\n}, (error) => {\n    console.error(error.response.body);\n});",
              "name": "node-sdk-v3"
            },
            {
              "language": "node",
              "install": "npm install asana@1.0.5",
              "code": "const asana = require('asana');\n\nconst client = asana.Client.create().useAccessToken('PERSONAL_ACCESS_TOKEN');\n\nclient.tasks.getTasks({param: \"value\", param: \"value\", opt_pretty: true})\n    .then((result) => {\n        console.log(result);\n    });",
              "name": "node-sdk-v1"
            },
            {
              "language": "python",
              "install": "pip install asana",
              "code": "import asana\nfrom asana.rest import ApiException\nfrom pprint import pprint\n\nconfiguration = asana.Configuration()\nconfiguration.access_token = '<YOUR_ACCESS_TOKEN>'\napi_client = asana.ApiClient(configuration)\n\n# create an instance of the API class\ntasks_api_instance = asana.TasksApi(api_client)\nopts = {\n    'limit': 50, # int | Results per page. The number of objects to return per page. The value must be between 1 and 100.\n    'offset': \"eyJ0eXAiOJiKV1iQLCJhbGciOiJIUzI1NiJ9\", # str | Offset token. An offset to the next page returned by the API. A pagination request will return an offset token, which can be used as an input parameter to the next request. If an offset is not passed in, the API will return the first page of results. *Note: You can only pass in an offset that was returned to you via a previously paginated request.*\n    'assignee': \"14641\", # str | The assignee to filter tasks on. If searching for unassigned tasks, assignee.any = null can be specified. *Note: If you specify `assignee`, you must also specify the `workspace` to filter on.*\n    'project': \"321654\", # str | The project to filter tasks on.\n    'section': \"321654\", # str | The section to filter tasks on.\n    'workspace': \"321654\", # str | The workspace to filter tasks on. *Note: If you specify `workspace`, you must also specify the `assignee` to filter on.*\n    'completed_since': '2012-02-22T02:06:58.158Z', # datetime | Only return tasks that are either incomplete or that have been completed since this time.\n    'modified_since': '2012-02-22T02:06:58.158Z', # datetime | Only return tasks that have been modified since the given time.  *Note: A task is considered “modified” if any of its properties change, or associations between it and other objects are modified (e.g.  a task being added to a project). A task is not considered modified just because another object it is associated with (e.g. a subtask) is modified. Actions that count as modifying the task include assigning, renaming, completing, and adding stories.*\n    'custom_type': \"12345\", # str | Filter results by custom type. Provide a custom type GID to return only objects of that custom type (an unknown GID returns `400`). Provide an empty string to return only objects with no custom type assigned. If this parameter is omitted, results are not filtered by custom type.\n    'opt_fields': \"actual_time_minutes,approval_status,assigned_by,assigned_by.name,assignee,assignee.name,assignee_section,assignee_section.name,assignee_status,completed,completed_at,completed_by,completed_by.name,created_at,created_by,custom_fields,custom_fields.asana_created_field,custom_fields.created_by,custom_fields.created_by.name,custom_fields.currency_code,custom_fields.custom_label,custom_fields.custom_label_position,custom_fields.date_value,custom_fields.date_value.date,custom_fields.date_value.date_time,custom_fields.default_access_level,custom_fields.description,custom_fields.display_value,custom_fields.enabled,custom_fields.enum_options,custom_fields.enum_options.color,custom_fields.enum_options.enabled,custom_fields.enum_options.name,custom_fields.enum_value,custom_fields.enum_value.color,custom_fields.enum_value.enabled,custom_fields.enum_value.name,custom_fields.format,custom_fields.has_notifications_enabled,custom_fields.html_text_value,custom_fields.id_prefix,custom_fields.input_restrictions,custom_fields.is_formula_field,custom_fields.is_global_to_workspace,custom_fields.is_value_read_only,custom_fields.multi_enum_values,custom_fields.multi_enum_values.color,custom_fields.multi_enum_values.enabled,custom_fields.multi_enum_values.name,custom_fields.name,custom_fields.number_value,custom_fields.people_value,custom_fields.people_value.name,custom_fields.precision,custom_fields.privacy_setting,custom_fields.reference_value,custom_fields.reference_value.name,custom_fields.representation_type,custom_fields.resource_subtype,custom_fields.text_value,custom_fields.type,custom_type,custom_type.asana_created_type_identifier,custom_type.name,custom_type_status_option,custom_type_status_option.name,dependencies,dependents,due_at,due_on,effective_memberships,external,external.data,followers,followers.name,has_subtasks_date_mismatch,hearted,hearts,hearts.user,hearts.user.name,html_notes,is_rendered_as_separator,liked,likes,likes.user,likes.user.name,memberships,memberships.project,memberships.project.name,memberships.project.resource_subtype,memberships.section,memberships.section.name,modified_at,name,notes,num_hearts,num_likes,num_subtasks,offset,parent,parent.created_by,parent.name,parent.resource_subtype,path,permalink_url,projects,projects.name,projects.resource_subtype,resource_subtype,start_at,start_on,tags,tags.name,uri,workspace,workspace.name\", # list[str] | This endpoint returns a resource which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. Properties can include nested fields. To learn more, see the [input/output options guide](/docs/inputoutput-options#selecting-nested-fields).\n}\n\ntry:\n    # Get multiple tasks\n    api_response = tasks_api_instance.get_tasks(opts)\n    for data in api_response:\n        pprint(data)\nexcept ApiException as e:\n    print(\"Exception when calling TasksApi->get_tasks: %s\\n\" % e)",
              "name": "python-sdk-v5"
            },
            {
              "language": "python",
              "install": "pip install asana==3.2.3",
              "code": "import asana\n\nclient = asana.Client.access_token('PERSONAL_ACCESS_TOKEN')\n\nresult = client.tasks.get_tasks({'param': 'value', 'param': 'value'}, opt_pretty=True)",
              "name": "python-sdk-v3"
            },
            {
              "language": "php",
              "install": "composer require asana/asana",
              "code": "<?php\nrequire 'vendor/autoload.php';\n\n$client = Asana\\Client::accessToken('PERSONAL_ACCESS_TOKEN');\n\n$result = $client->tasks->getTasks(array('param' => 'value', 'param' => 'value'), array('opt_pretty' => 'true'))"
            },
            {
              "language": "ruby",
              "install": "gem install asana",
              "code": "require 'asana'\n\nclient = Asana::Client.new do |c|\n    c.authentication :access_token, 'PERSONAL_ACCESS_TOKEN'\nend\n\nresult = client.tasks.get_tasks(param: \"value\", param: \"value\", options: {pretty: true})"
            }
          ]
        }
      }
    }
  }
}
```